
import { describe, test, it, expect } from 'vitest'
import {RuntimeConfig} from "@nuxt/schema";
import {AnyAbility} from "@casl/ability/dist/types";
import {AccessProfile, organizationState} from "~/types/interfaces";
import StatsMenuBuilder from "~/services/layout/menuBuilder/statsMenuBuilder";
import {MenuGroup} from "~/types/layout";
import {MENU_LINK_TYPE} from "~/types/enum/layout";

let runtimeConfig: RuntimeConfig
let ability: AnyAbility
let organizationProfile: organizationState
let accessProfile: AccessProfile
let menuBuilder: StatsMenuBuilder

beforeEach(()=> {
    runtimeConfig = vi.fn() as any as RuntimeConfig
    ability = vi.fn() as any as AnyAbility
    organizationProfile = vi.fn() as any as organizationState
    accessProfile = vi.fn() as any as AccessProfile

    runtimeConfig.baseUrlAdminLegacy = 'https://mydomain.com/'

    menuBuilder = new StatsMenuBuilder(runtimeConfig, ability, organizationProfile, accessProfile)
})


describe('getMenuName', () => {
    test('validate name', () => {
        expect(menuBuilder.getMenuName()).toEqual("Stats")
    })
})


describe('build', () => {
    test('has all items', () => {
        ability.can = vi.fn(() => true)

        // Should return a MenuGroup
        const result = menuBuilder.build() as MenuGroup

        expect(result.label).toEqual('stats')
        expect(result.icon).toEqual({name: 'fas fa-chart-bar'})
        // @ts-ignore
        expect(result.children.length).toEqual(4)
    })

    test('has no items', () => {
        ability.can = vi.fn(() => false)
        expect(menuBuilder.build()).toEqual(null)
    })

    test('has only rights for menu report_activity', () => {
        ability.can = vi.fn((action: string, subject: string) => action === 'display' && subject === 'report_activity_page')

        expect(menuBuilder.build()).toEqual(
            {label: 'report_activity', icon: {name: 'fas fa-chart-bar'}, to: 'https://mydomain.com/report_activity', type: MENU_LINK_TYPE.V1, active: false}
        )
    })

    test('has only rights for menu fede_stats', () => {
        ability.can = vi.fn((action: string, subject: string) => action === 'display' && subject === 'fede_stats_page')

        expect(menuBuilder.build()).toEqual(
            {label: 'fede_stats', icon: {name: 'fas fa-chart-bar'}, to: 'https://mydomain.com/statistic/membersfedeonly', type: MENU_LINK_TYPE.V1, active: false}
        )
    })

    test('has only rights for menu structure_stats', () => {
        ability.can = vi.fn((action: string, subject: string) => action === 'display' && subject === 'structure_stats_page')

        expect(menuBuilder.build()).toEqual(
            {label: 'structure_stats', icon: {name: 'fas fa-chart-bar'}, to: 'https://mydomain.com/statistic/membersfedeassos', type: MENU_LINK_TYPE.V1, active: false}
        )
    })
})
